$(document).ready(function() {


    var App = {

        init: function() {
            App.frontWords = SUGGEST_FRON_WORDS;

            App.backWords = SUGGEST_BACK_WORDS;

            App.delayBetweenRequests = 500;
            if(localStorage.delayBetweenRequests) {
                App.delayBetweenRequests = JSON.parse(localStorage.delayBetweenRequests);
            }
            $('#delay').val(App.delayBetweenRequests);

            // cache jquery
            App.$keyword = $('#keyword');
            App.$progress = $('#progress');
            App.$bar = App.$progress.find('.progress-bar');
            App.$results = $('#results');
			App.$progressText = $('#progress-text');

            App.currentQueryNum = 0;
            App.variantsCount = 0;

            App.resultList = [];

            if(localStorage.keyword) {
                var keyword = JSON.parse(localStorage.keyword);
                App.$keyword.val(keyword);
            }

            $('#btn-search').click(App.clickBtnSearch);
        },

        clickBtnSearch: function(e) {
            e.preventDefault();

            App.delayBetweenRequests = 1 * $('#delay').val();
            localStorage.delayBetweenRequests = JSON.stringify(App.delayBetweenRequests);

            App.$results.val('');
            $('.js-copy-btn').removeAttr('disabled').text('Copy to clipboard');

            var query,
                delayTimeout = 0;

            var mainKeyword = App.$keyword.val();
            localStorage.keyword = JSON.stringify(mainKeyword);

            App.variantsCount = App.frontWords.length * App.backWords.length;
            App.currentQueryNum = 0;

            App.updateProgressBar();

            for(var fw = 0; fw < App.frontWords.length; fw++) {
                for(var bw = 0; bw < App.backWords.length; bw++) {
                    query = App.frontWords[fw] + ' ' + mainKeyword + ' ' + App.backWords[bw];

                    App.doSetTimeout(query, delayTimeout);

                    var delay = App.delayBetweenRequests;
                    var delayDiff = Math.round(Math.random() * 100) / 100;
                    delay = delay - (delay * 0.8) * delayDiff;
                    delayTimeout+= delay;
                    //console.log(delayTimeout, delay);
                }
            }
        },

        doSetTimeout: function(query, delayTimeout) {
            setTimeout(function() {
                //console.log(query);
                App.askSuggestion(query);
            }, delayTimeout + Math.random() * 100);
        },

        askSuggestion: function(keyword) {
            var url = 'http://suggestqueries.google.com/complete/search?client=chrome&q=' + keyword + '&callback=callback';

            var $results = $('#results');

            $.ajax({
                url: url,
                type: 'get',
                jsonp: "callback",
                dataType: "jsonp",
                success: function(response) {
                    //console.log(response);

                    var data = response[1];
                    var text = '';

                    for(var i = 0; i < data.length; i++) {
                        // remove duplicates
                        if(App.resultList.indexOf(data[i]) >= 0) {
                            continue;
                        }
                        App.resultList.push(data[i]);

                        text+= data[i] + '\r\n';
                    }

                    text = $results.val() + text;
                    $results.val(text);

                    App.currentQueryNum++;
                    App.updateProgressBar();
                },
                error: function() {
                    //alert("The response could not be processed correctly.");
                    console.log("The response could not be processed correctly.");
                    console.log();
                }

            });
        },

        updateProgressBar: function() {
            App.$progress.show();

            if(App.currentQueryNum <= 0 || App.currentQueryNum >= App.variantsCount) {
                App.$bar.removeClass('active');
            }
            else{
                App.$bar.addClass('active');
            }

			App.$progressText.text(App.currentQueryNum + ' / ' + App.variantsCount);

			//console.log('progress: ' + App.currentQueryNum + ' / ' + App.variantsCount + ' // ' +  Math.round(App.currentQueryNum / App.variantsCount * 100) + '%');

            var width = Math.round(App.currentQueryNum / App.variantsCount * 100);

            App.$bar.width(width + '%');
        }

    };

    App.init();

});